WARNING: NANDFS is considered to be a highly experimental feature in FreeBSD.

You might run into issues like:
# mount -t nandfs /dev/gnand0s.root /mnt
Cannot find valid SuperRoot

in such cases -> drop and recreate nandfs.

After applying this patch please also read:

https://wiki.freebsd.org/NAND
https://wiki.freebsd.org/FreeBSDMarvell

cd /usr/src/
make -j 8 buildworld TARGET_ARCH=arm -DWITH_NAND
mkdir -p /build/dockstar
setenv DESTDIR /build/dockstar
make installworld TARGET_ARCH=arm -DWITH_NAND
make distrib-dirs TARGET_ARCH=arm -DWITH_NAND
make distribution TARGET_ARCH=arm -DWITH_NAND
make buildkernel TARGET_ARCH=arm KERNCONF=DOCKSTAR
make installkernel TARGET_ARCH=arm KERNCONF=DOCKSTAR
cp -a /usr/obj/arm.arm/usr/src/sys/DOCKSTAR/kernel.bin /build/dockstar

--- sys/arm/conf/DOCKSTAR	2018-06-21 23:02:43 UTC
+++ sys/arm/conf/DOCKSTAR	2018-07-29 18:18:31 UTC
@@ -1,7 +1,7 @@
 #
 # Custom kernel for Seagate DockStar (Marvell SheevaPlug based) devices.
 #
-# $FreeBSD: releng/11.2/sys/arm/conf/DOCKSTAR 302915 2016-07-15 21:30:19Z ian $
+# $FreeBSD: releng/11.2/sys/arm/conf/DOCKSTAR 302915 2018-07-29 18:15:22Z ripp $
 #
 #    http://www.FreeBSD.org/doc/en_US.ISO8859-1/books/handbook/kernelconfig-config.html
 #
@@ -15,7 +15,7 @@
 # If you are in doubt as to the purpose or necessity of a line, check first 
 # in NOTES.
 #
-# $FreeBSD: releng/11.2/sys/arm/conf/DOCKSTAR 302915 2016-07-15 21:30:19Z ian $
+# $FreeBSD: releng/11.2/sys/arm/conf/DOCKSTAR 302915 2018-07-29 18:15:22Z ripp $
 #
 #NO_UNIVERSE
 
@@ -37,6 +37,7 @@
 options 	MSDOSFS			# MSDOS Filesystem
 options 	CD9660			# ISO 9660 filesystem
 options 	NULLFS			# NULL filesystem
+options 	NANDFS			# NAND Filesystem
 options 	TMPFS			# Efficient memory filesystem
 options 	GEOM_PART_GPT		# GUID Partition Tables
 options 	GEOM_PART_BSD		# BSD partition scheme
@@ -55,8 +56,9 @@
 #options 	BOOTP_WIRED_TO=mge0
 
 # If not using BOOTP, use something like one of these...
+options 	ROOTDEVNAME=\"nandfs:/dev/gnand0s.root\"
 #options 	ROOTDEVNAME=\"ufs:/dev/da0a\"
-options 	ROOTDEVNAME=\"ufs:/dev/da0s1a\"
+#options 	ROOTDEVNAME=\"ufs:/dev/da0s1a\"
 #options 	ROOTDEVNAME=\"ufs:/dev/da0p10\"
 #options 	ROOTDEVNAME=\"nfs:192.168.0.254/dreamplug\"
 
@@ -73,6 +75,9 @@
 device		vlan			# 802.1Q VLAN support
 device		wlan			# 802.11 WLAN support
 
+# NAND
+device		nand
+
 # cam support for umass and ahci
 device		scbus
 device		pass
@@ -115,41 +120,9 @@
 device		crypto
 device		cryptodev
 
-# IPSec
-device		enc
-options 	IPSEC
-options 	IPSEC_NAT_T
-options 	TCP_SIGNATURE		# include support for RFC 2385
-
-# IPFW
-options 	IPFIREWALL
-options 	IPFIREWALL_DEFAULT_TO_ACCEPT
-options 	IPFIREWALL_VERBOSE
-options 	IPFIREWALL_VERBOSE_LIMIT=100
-options 	IPFIREWALL_NAT
-options 	LIBALIAS
-options 	DUMMYNET
-options 	IPDIVERT
-
-#PF 
-device		pf
-device		pflog
-device		pfsync
-
 # GPIO
 device		gpio
 
-# ALTQ, required for PF
-options 	ALTQ			# Basic ALTQ support
-options 	ALTQ_CBQ		# Class Based Queueing
-options 	ALTQ_RED		# Random Early Detection
-options 	ALTQ_RIO		# RED In/Out
-options 	ALTQ_HFSC		# Hierarchical Packet Scheduler
-options 	ALTQ_CDNR		# Traffic conditioner
-options 	ALTQ_PRIQ		# Priority Queueing
-options 	ALTQ_NOPCC		# Required if the TSC is unusable
-#options 	ALTQ_DEBUG
-
 # Flattened Device Tree
 options 	FDT			# Configure using FDT/DTB data
 options 	FDT_DTB_STATIC
--- sys/boot/fdt/dts/arm/dockstar.dts	2018-06-21 23:02:49 UTC
+++ sys/boot/fdt/dts/arm/dockstar.dts	2018-07-29 18:09:44 UTC
@@ -28,7 +28,7 @@
  *
  * Seagate DockStar (Marvell SheevaPlug based) Device Tree Source.
  *
- * $FreeBSD: releng/11.2/sys/boot/fdt/dts/arm/dockstar.dts 301222 2016-06-02 18:35:35Z zbb $
+ * $FreeBSD: releng/11.2/sys/boot/fdt/dts/arm/dockstar.dts 301222 2018-07-29 18:03:37Z ripp $
  */
 
 /dts-v1/;
@@ -86,6 +86,22 @@
 			reg = <0x0 0x0 0x00100000>;
 			bank-width = <2>;
 			device-width = <1>;
+
+			slice@0 {
+				reg = <0x0 0x200000>;
+				label = "u-boot";
+				read-only;
+			};
+
+			slice@200000 {
+				reg = <0x200000 0xa00000>;
+				label = "fbsd-boot";
+			};
+
+			slice@c00000 {
+				reg = <0xc00000 0xf400000>;
+				label = "root";
+			};
 		};
 	};
 
